<?php
/*============================================================================*\
|| ########################################################################## ||
|| # Rotating Banner System - Click Tracker                                 # ||
|| # ---------------------------------------------------------------------- # ||
|| # (C) Copyright Y2K Software s.a.s. 2008-2012 - All Rights Reserved.     # ||
|| # This file may not be redistributed in whole or significant part.       # ||
|| ########################################################################## ||
\*============================================================================*/

/**
 * @author Y2K Software
 * @copyright (C) Copyright Y2K Software 2008-2012 - All Rights Reserved
 * @version 2.4.0
 * @link www.pagerobot.com
 */

error_reporting(0);

define('THIS_SCRIPT', 'rbs_banner');
define('VB_AREA', 'Forum');
define('CSRF_PROTECTION', false);

define('NOSHUTDOWNFUNC', 1);
define('NOCOOKIES', 1);
define('NOPMPOPUP', 1);
define('SKIP_SESSIONCREATE', 1);
define('SKIP_USERINFO', 1);
define('SKIP_DEFAULTDATASTORE', 1);
define('CWD', (($getcwd = getcwd()) ? $getcwd : '.'));

$phrasegroups = array();
$specialtemplates = array();
$globaltemplates = array();
$actiontemplates = array();

require_once (CWD . '/includes/init.php');

$vbulletin->input->clean_array_gpc('r', array('id' => TYPE_UINT, 'userid' => TYPE_UINT));

$bannerid = $vbulletin->GPC['id'];

// Get image banner ------------------------------------------------------------
$vbulletin->db->hide_errors();
$SQL = "SELECT url
    FROM " . TABLE_PREFIX . "rbs_banners
    WHERE id=$bannerid";
if($rs = $vbulletin->db->query_first($SQL))
{
    $userid = $vbulletin->GPC['userid'];
    $dateline = TIMENOW;
    $ip = $vbulletin->db->escape_string($_SERVER['REMOTE_ADDR']);
    $referer = $vbulletin->db->escape_string($_SERVER['HTTP_REFERER']);
    $servername = $vbulletin->db->escape_string($_SERVER['SERVER_NAME']);

    /**
     * In order to count properly the clicks, we also implement some typical
     * click fraud blockers:
     * 1. Ad is enabled and visible (query controlled).
     * 2. Number of clicks is even or larger than the impression count (query
     *    controlled).
     * 3. Clicks from other sites (the referer isn't coming from the forum).
     */
    if(!$vbulletin->options['rbs_disable_click_counter'])
    {
        if(strpos(strtolower($_SERVER['HTTP_REFERER']), strtolower($vbulletin->options['bburl'])) !== false)
        {
            $SQL = "UPDATE " . TABLE_PREFIX . "rbs_banners
                SET clicks=clicks+1
                WHERE enabled=1
                    AND id=$bannerid
                    AND startdate<=$dateline
                    AND enddate>=$dateline
                    AND clicks<impressions
                    AND IF(clicktrack, maxclicks=0 OR (maxclicks>0 AND clicks<maxclicks), 1)
                    ";
            $vbulletin->db->query_write($SQL);
        }
    }
    
    /**
     * Hits (accepts anything)
     * 
     * The difference between COUNT(*) and clicks are useful to check for fraud 
     * attempts or direct access (from spiders).
     */
    if(!$vbulletin->options['rbs_disable_hit_counter'])
    {
        $SQL = "INSERT INTO " . TABLE_PREFIX . "rbs_hits SET
                bannerid=$bannerid, 
                userid=$userid, 
                dateline=$dateline, 
                ip='$ip', 
                servername='$servername', 
                referer='$referer'";
        $vbulletin->db->query_write($SQL);
    }

    // Redirect to final landing page
    if($rs['url'])
    {
        header('Location: ' . $rs['url']);
    }
}
